#include "asteroid.h"

//------------------------------------------------------------------------------

//Constructor
CAsteroid::CAsteroid(DATAFILE *d, BITMAP *Spark)
{
    Data = d;
    //Occasionally, a flying toaster will pop up...
    if ((rand() % 30) == 0)
        SpriteIndex = TOASTER;
    else
        SpriteIndex = 0;
    NumSprites = 18;
    SpinSpeed = 0.01 + (float)rand()/(float)RAND_MAX*0.3;
    X = rand() % SCREEN_W;
    Y = SCREEN_H + rand() % SCREEN_H/2;
    dY = -0.2 - (float)rand()/(float)RAND_MAX*0.5;
    dX = -0.5 + (float)rand()/(float)RAND_MAX;
    Expl = new CExplosion(300, 0.6, X, Y, 0.02, Spark);
}
//------------------------------------------------------------------------------

//Destructor
CAsteroid::~CAsteroid()
{
    delete Expl;
}
//------------------------------------------------------------------------------

//Update
void CAsteroid::Update()
{
    X += dX;
    Y += dY;
    if (Y < -40 || X+((BITMAP *)Data[(int)SpriteIndex].dat)->w < 0 || X > SCREEN_W)
    {
        X = rand() % SCREEN_W;
        Y = SCREEN_H + rand() % SCREEN_H/2;
        dY = -0.2 - (float)rand()/(float)RAND_MAX*0.5;
        dX = -0.5 + (float)rand()/(float)RAND_MAX;
        if ((rand() % 30) == 0)
            SpriteIndex = TOASTER;
        else
            SpriteIndex = 0;
    }
    //Spin around
    if (SpriteIndex != TOASTER)
    {
        SpriteIndex += SpinSpeed;
        if (SpriteIndex >= NumSprites)
            SpriteIndex = 0;
    }
    //Update explosion
    Expl->Update();
}
//------------------------------------------------------------------------------

//Draw
void CAsteroid::Draw(BITMAP *Dest)
{
    draw_sprite(Dest, (BITMAP *)Data[(int)SpriteIndex].dat, (int)X, (int)Y);
    Expl->Draw(Dest);
}
//------------------------------------------------------------------------------

//Has collided with player
void CAsteroid::Explode()
{
    if (!Expl->Exploding())
    {
        play_sample((SAMPLE*)Globals::SfxDat[EXPLSAMPLE].dat, 200, 128, 1000, false);
        //Start explosion
        Expl->Reset(MidX(), MidY());
        Expl->Start();
        //Move
        X = rand() % SCREEN_W;
        Y = SCREEN_H + rand() % SCREEN_H/2;
        dY = -0.2 - (float)rand()/(float)RAND_MAX*0.5;
        dX = -0.5 + (float)rand()/(float)RAND_MAX;
        if ((rand() % 30) == 0)
            SpriteIndex = TOASTER;
        else
            SpriteIndex = 0;
    }
}
//------------------------------------------------------------------------------
