#ifndef ASTEROID_H
#define ASTEROID_H

#include "gameobject.h"
#include "explosion.h"
#include "data/astsprites.h"

//An asteroid

class CAsteroid : public TGameObject
{
    public:
        CAsteroid(DATAFILE *d, BITMAP *Spark);
        ~CAsteroid();
        void Update();
        void Draw(BITMAP *Dest);
        void Explode();
        //For collision detection
        float MidX() {return X+((BITMAP*)Data[(int)SpriteIndex].dat)->w/2;}
        float MidY() {return Y+((BITMAP*)Data[(int)SpriteIndex].dat)->h/2;}
        float Radius() {return ((BITMAP*)Data[(int)SpriteIndex].dat)->h/2;}
    private:
        DATAFILE *Data;
        float SpriteIndex, SpinSpeed;
        int NumSprites;
        //Explosion
        CExplosion *Expl;
};

#endif
