#ifndef ENEMYSHIP_H
#define ENEMYSHIP_H

#include <vector>
#include "gameobject.h"
#include "data/sprites.h"
#include "explosion.h"
using namespace std;

struct Bullet
{
    Bullet(float x, float y){X = x; Y = y; Remove = false;}
    float X, Y;
    bool Remove;
};
typedef vector<Bullet*>::iterator Bit;

//An enemy
class CEnemyShip : public TGameObject
{
    public:
        CEnemyShip(int l, DATAFILE *d);
        ~CEnemyShip();
        void Update();
        void Draw(BITMAP *Dest);
        void Reset();
        int TakeDamage(int Dmg);
        //For collision detection
        float MidX() {return X+Sprite->w/2;}
        float MidY() {return Y+Sprite->h/2;}
        float Radius() {return Sprite->h/2;}
        bool Remove, Exploding;
        
        //Weapon
        vector<Bullet *> Weapon;
    private:
        //Level of badness
        int Level;
        //Movement
        float DestX;
        float Acceleration, MaxSpeed;
        int Shields, MaxShields;
        BITMAP *Sprite;
        DATAFILE *SpriteData;
        int Reload, ReloadTime;
        //Explosion
        CExplosion *Expl;
};

#endif
