#ifndef GAME_MANAGER_H
#define GAME_MANAGER_H

#include <vector>
#include <allegro.h>
#include "data/sprites.h"
#include "starfield.h"
#include "globals.h"
#include "playership.h"
#include "asteroid.h"
#include "enemyship.h"
#include "menu.h"
#include "highscore.h"
using namespace std;

//The big boss class. Takes care of general stuff.

class CGameManager
{
    public:
        CGameManager();
        ~CGameManager();
        //Run menus and game
        void Run();
        //Run the game loop
        int GameLoop();
    private:
        //Create a new wave
        void NewWave(int &W);
        //The player
        CPlayerShip *Player;
        //The background of the game
        CStarField *StarField;
        //Baddies
        vector<CAsteroid *> Asteroids;
        vector<CEnemyShip *> Enemies;
        //Menu
        CMenuManager *Menu;
        CHighscoreManager *Highscores;
        //Buffer
        BITMAP *Buffer;
        //Data
        DATAFILE *Sprites;
        DATAFILE *AstSprites;
        DATAFILE *GuiData;
};

typedef vector<CAsteroid*>::iterator Ait;
typedef vector<CEnemyShip*>::iterator Eit;

#endif
