#include "guibutton.h"
//------------------------------------------------------------------------------

//Constructor
CGuiButton::CGuiButton(int x, int y, BITMAP *u, BITMAP *d, string t, FONT *f, int tc)
 : TGuiObject(x, y, u->w, d->h)
{
    Font = f;
    Text = t;
    Up = u;
    Down = d;
    TextColor = tc;
    ClickFlag = false;
}
//------------------------------------------------------------------------------

//Destruktor
CGuiButton::~CGuiButton()
{
    destroy_bitmap(Up);
    destroy_bitmap(Down);
}
//------------------------------------------------------------------------------

//Update
void CGuiButton::Update()
{
    //If mouse button is down over button, it is pressed
    if (mouse_x > X && mouse_x < X+W)
    {
        if (mouse_y > Y && mouse_y < Y+H)
        {
            if (mouse_b & 1 && !IsPressed)
            {
                IsPressed = true;
            }
            else if (!mouse_b & 1 && IsPressed)
            {
                IsPressed = false;
                ClickFlag = true;
            }
        }
        else
            IsPressed = false;
    }
    else
        IsPressed = false;
}
//------------------------------------------------------------------------------

//Draw the button
void CGuiButton::Draw(BITMAP *Dest)
{
    text_mode(-1);

    if (IsPressed)
        masked_blit(Down, Dest, 0, 0, X, Y, W, H);
    else
        masked_blit(Up, Dest, 0, 0, X, Y, W, H);

    textout_centre(Dest, Font, Text.c_str(), X+W/2, Y+H/2-text_height(Font)/2, TextColor );
}
//------------------------------------------------------------------------------
