#include "guistring.h"

//------------------------------------------------------------------------------

//Constructor
CGuiString::CGuiString(int x, int y, int max, string t, FONT *f, int tc, int bgc)
    : TGuiObject(x, y, 0, text_height(f)) //Calc length later
{
    MaxLength = max;
    Text = t;
    Font = f;
    TextColor = tc;
    Background = bgc;

    assert(Text.size() <= MaxLength);

    //Calculate length
    string MaxString (MaxLength, 'A');
    W = text_length(Font, MaxString.c_str());
}
//------------------------------------------------------------------------------

//Update
void CGuiString::Update()
{
    //Check if selected
    if (mouse_x > X && mouse_x < X+W)
    {
        if (mouse_y > Y && mouse_y < Y+H)
        {
            if (!IsSelected)
            {
                IsSelected = true;
                clear_keybuf();
            }
        }
        else
            IsSelected = false;
    }
    else
        IsSelected = false;

    //Read text
    if (IsSelected)
    {
        if (keypressed())
        {
            int Key = readkey();
            if (Key >> 8 == KEY_BACKSPACE && !Text.empty())
                Text.erase(Text.size()-1, 1);
            else if (Text.size() < MaxLength && scancode_to_ascii(Key >> 8) != 0)
            {
                if (Key >> 8 != KEY_BACKSPACE)
                    Text += Key;
            }
        }
    }
}
//------------------------------------------------------------------------------

//Draw
void CGuiString::Draw(BITMAP *Dest)
{
    //Frame
    text_mode(-1);
    //BG
    rectfill(Dest, X, Y, X+W, Y+H, Background);
    if (IsSelected)
        rect(Dest, X-1, Y-1, X+W, Y+H, makecol(255, 255, 255));
    textprintf(Dest, Font, X, Y, TextColor, Text.c_str());
}
//------------------------------------------------------------------------------

