#include <fstream>
#include <allegro.h>
#include <ctime>
#include <cstdlib>
#include "gamemanager.h"
using namespace std;

//Timer func
void Tick()
{
    Globals::Counter++;
}
END_OF_FUNCTION(Tick);

//Keep track of frames per second
void Secs()
{
    Globals::FPS = Globals::Frames;
    Globals::Frames = 0;
}
END_OF_FUNCTION(Secs);

int main()
{
    allegro_init();
    install_keyboard();
    install_timer();
    install_mouse();
    install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL);
    srand(time(0));
    int ColorDepth = 16;
    ifstream Fin("Color.txt");
    if (Fin)
        Fin >> ColorDepth;
    Fin.close();
    set_color_depth(ColorDepth);
    set_window_title("Earth Invaders");
	set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);
	
	//Setup timer
	LOCK_FUNCTION(Tick);
	LOCK_FUNCTION(Secs);
	LOCK_VARIABLE(Globals::Counter);
	LOCK_VARIABLE(Globals::FPS);
	LOCK_VARIABLE(Globals::Frames);
	install_int_ex(Tick, BPS_TO_TIMER(Globals::GameSpeed));
	install_int_ex(Secs, SECS_TO_TIMER(1));

    //Create a game manager and run
    CGameManager *GameMan = new CGameManager;
    GameMan->Run();
    delete GameMan;

	return 0;
}
END_OF_MAIN();
