#ifndef MENU_H
#define MENU_H

#include <allegro.h>
#include "guibutton.h"
#include "guistring.h"
#include "data/guidat.h"
#include "globals.h"
#include "starfield.h"
#include "highscore.h"

//The menu handler

class CMenuManager
{
    public:
        CMenuManager(DATAFILE *d, FONT *SmallFont);
        ~CMenuManager();
        int MainMenu();
        void ShowHighscores(CHighscoreManager *Highscores);
        void AddHighscoreEntry(CHighscoreManager *Highscores, int Score);
        void ViewStory();
    private:
        void MoveStars();
        void DrawStars();
    
        DATAFILE *Data;
        FONT *SmallFont;
        BITMAP *Buffer;
        BITMAP *Cursor;
        //Buttons
        CGuiButton *PlayBtn, *HighscoreBtn, *ExitBtn;
        CGuiString *HighscoreStrn;
        //Starfield
        CStar *Stars1, *Stars2, *Stars3;
        int NumStars;
};

#endif
