#include "starfield.h"

//------------------------------------------------------------------------------

//Constructor
CStarField::CStarField(int num, DATAFILE *dat)
{
    NumStars = num;
    Stars1 = new CStar[NumStars];
    Stars2 = new CStar[NumStars];
    Stars3 = new CStar[NumStars];
    Data = dat;

    //Setup the starfields
    for (int i = 0; i < NumStars; ++i)
    {
        Stars1[i].X = rand() % SCREEN_W;
        Stars1[i].Y = rand() % SCREEN_H;
        int C = 150 + rand() % 155;
        Stars1[i].Col = makecol(C, C, C);

        Stars2[i].X = rand() % SCREEN_W;
        Stars2[i].Y = rand() % SCREEN_H;
        C = 100 + rand() % 100;
        Stars2[i].Col = makecol(C, C, C);
        
        Stars3[i].X = rand() % SCREEN_W;
        Stars3[i].Y = rand() % SCREEN_H;
        C = 50 + rand() % 150;
        Stars3[i].Col = makecol(C, C, C);
    }
}
//------------------------------------------------------------------------------

//Destructor
CStarField::~CStarField()
{
    delete []Stars1;
    delete []Stars2;
    delete []Stars3;
}
//------------------------------------------------------------------------------

//Move the stars
void CStarField::Update()
{
    for (int i = 0; i < NumStars; ++i)
    {
        Stars1[i].Y -= 0.7;
        if (Stars1[i].Y < 0) Stars1[i].Y = SCREEN_H;
        
        Stars2[i].Y -= 0.4;
        if (Stars2[i].Y < 0) Stars2[i].Y = SCREEN_H;
        
        Stars3[i].Y -= 0.1;
        if (Stars3[i].Y < 0) Stars3[i].Y = SCREEN_H;
    }    
}
//------------------------------------------------------------------------------

//Draw the starfield
void CStarField::Draw(BITMAP *Dest)
{
    //Draw Mars
    draw_sprite(Dest, (BITMAP *)Data[MARS].dat, 450, 70);
    //Draw the stars
    for (int i = 0; i < NumStars; ++i)
    {
        putpixel(Dest, (int)Stars1[i].X, (int)Stars1[i].Y, Stars1[i].Col);
        putpixel(Dest, (int)Stars2[i].X, (int)Stars2[i].Y, Stars2[i].Col);
        putpixel(Dest, (int)Stars3[i].X, (int)Stars3[i].Y, Stars3[i].Col);
    }
}
//------------------------------------------------------------------------------
