#include "trail.h"

//------------------------------------------------------------------------------

//Constructor
CTrail::CTrail(int num, float x, float y, float force, float dl, BITMAP *sprite)
{
    Started = false;
    NumParticles = num;
    X = x;
    Y = y;
    Force = force;
    Sprite = sprite;
    dLife = dl;
    Particles = new CParticle[NumParticles](Sprite);
    for (int i = 0; i < NumParticles; ++i)
        Particles[i].Reset(X, Y, Rand(-Force, Force), Rand(-Force, Force), 
            Rand(dLife*0.7, dLife*1.3));
}
//------------------------------------------------------------------------------

//Destructor
CTrail::~CTrail()
{
    delete []Particles;
}
//------------------------------------------------------------------------------

//Start the effect
void CTrail::Start()
{
    Started = true;
}
//------------------------------------------------------------------------------

//Stop the effect
void CTrail::Stop()
{
    Started = false;
}
//------------------------------------------------------------------------------

//Update all particles
void CTrail::Update(float x, float y)
{
    X = x;
    Y = y;
    
    for (int i = 0; i < NumParticles; ++i)
    {
        Particles[i].Update();
        if (Particles[i].IsDead())
        {
            Particles[i].Reset(X, Y, Rand(-Force, Force), Rand(-Force, Force),
                Rand(dLife*0.7, dLife*1.3));
        }
    }
}
//------------------------------------------------------------------------------

//Draw all particles
void CTrail::Draw(BITMAP *Dest)
{
    if (Started)
    {
        for (int i = 0; i < NumParticles; ++i)
            Particles[i].Draw(Dest);
    }
}
//------------------------------------------------------------------------------

//Ranged random
float CTrail::Rand(float Min, float Max)
{
    return Min + ((float)rand()/(float)RAND_MAX)*(Max-Min);
}
//------------------------------------------------------------------------------
