#ifndef WEAPON_H
#define WEAPON_H

#include <vector>
#include "gameobject.h"
#include "trail.h"
#include "data/sprites.h"
#include "asteroid.h"
#include "explosion.h"
#include "enemyship.h"
#include "globals.h"


using namespace std;

//A weapon
class CWeapon : public TGameObject
{
    public:
        CWeapon(WeaponType t, float x, float y, DATAFILE *d, vector<CAsteroid*> *a,
            vector<CEnemyShip*> *e);
        ~CWeapon();
        int Update();
        void Draw(BITMAP *Dest);
        int CheckCollision();
        
        bool Remove;
    private:
        WeaponType Type;
        int Damage;
        CTrail *Fire;
        CExplosion *Expl;
        BITMAP *Sprite;
        DATAFILE *SpriteData;
        int Angle;
        //For collision detection
        vector<CAsteroid*> *Astds;
        vector<CEnemyShip*> *Enemies;
};
typedef vector<CAsteroid*>::iterator Ait;
typedef vector<CEnemyShip*>::iterator Eit;
#endif
