#ifndef WEAPONMANAGER_H
#define WEAPONMANAGER_H

#include <string>
#include <vector>
#include "weapon.h"
#include "asteroid.h"
#include "enemyship.h"
using namespace std;

//A class that takes care of storing bullets, reloading etc...

class CWeaponManager
{
    public:
        CWeaponManager(WeaponType t, DATAFILE *d, vector<CAsteroid*> *a,
                    vector<CEnemyShip*> *e);
        CWeaponManager(WeaponType t, DATAFILE *d);
        ~CWeaponManager();
        void Fire(float x, float y);
        int Update();
        void Draw(BITMAP *Dest);
        float Reloaded(){return (float)(ReloadTime-Reload)/(float)ReloadTime;}
        BITMAP *NameBmp();
    private:
        DATAFILE *SpriteData;
        WeaponType Type;
        int Reload, ReloadTime;
        vector<CWeapon *> Bullets;
        vector<CAsteroid*> *Astds;
        vector<CEnemyShip*> *Enemies;
};
typedef vector<CWeapon *>::iterator Wit;
typedef vector<CEnemyShip*>::iterator Eit;

#endif
